
;; zweiter teil der funktionen

;********************
; Fenster und Bildschirm
;***********

(defun neq (a B)
     (not (eql a b)))

(defun b=Linie-in-Bereich-p (Anfangspunkt Endpunkt topleft bottomright)
  "testet, ob sich eine Linie und ein Rechteck schneiden"
  "Autor: Gnter, 18.1.93"
  (locally
    (declare (optimize (speed 3)(safety 0))
             (fixnum Anfangspunkt-x Anfangspunkt-y Endpunkt-x Endpunkt-y x1 x2 y1 y2))
  (let ((Anfangspunkt-x (point-h (the fixnum Anfangspunkt)))
        (Anfangspunkt-y (point-v (the fixnum Anfangspunkt)))
        (Endpunkt-x (point-h (the fixnum Endpunkt)))
        (Endpunkt-y (point-v (the fixnum Endpunkt)))
        (x1 (point-h (the fixnum topleft)))
        (x2 (point-h (the fixnum bottomright)))
        (y1 (point-v (the fixnum topleft)))
        (y2 (point-v (the fixnum bottomright))))
    (when (or (= (the fixnum x1) (the fixnum x2)) (= (the fixnum y1) (the fixnum y2))               ;das `when testet, ob sich das Rechteck, das die Linie umschliet, mit dem Rechteck schneidet
              (and (> (the fixnum x1) (the fixnum Anfangspunkt-x)) (> (the fixnum x1) (the fixnum Endpunkt-x)))
              (and (< (the fixnum x2) (the fixnum Anfangspunkt-x)) (< (the fixnum x2) (the fixnum Endpunkt-x)))
              (and (> (the fixnum y1) (the fixnum Anfangspunkt-y)) (> (the fixnum y1) (the fixnum Endpunkt-y)))
              (and (< (the fixnum y2) (the fixnum Anfangspunkt-y)) (< (the fixnum y2) (the fixnum Endpunkt-y))))
      (return-from b=Linie-in-Bereich-p nil))
    (let ((Linie-dx (- Endpunkt-x Anfangspunkt-x))   ;x-Koordinate des Richtungsvektors der Geraden
          (Linie-dy (- Endpunkt-y Anfangspunkt-y)))  ;y-Koordinate des Richtungsvektors der Geraden
      (flet ((Seite (x y)                             ;`Seite liefert zurck, auf welcher Seite der Punkt (x, y) liegt
               (let* ((dx (the fixnum (- (the fixnum x) (the fixnum Anfangspunkt-x))))      
                      (dy (the fixnum (- (the fixnum y) (the fixnum Anfangspunkt-y))))
                      (Kreuz (the fixnum (- (the fixnum (* (the fixnum dx) (the fixnum Linie-dy))) 
                                            (the fixnum (* (the fixnum dy) (the fixnum Linie-dx)))))))   ;Kreuzprodukt des Richtungsvektor und ...
                 (plusp (the fixnum kreuz)))))
        (if (eq (plusp (the fixnum linie-dx)) (plusp (the fixnum linie-dy)))
          (neq (seite x2 y1) (seite x1 y2))
          (neq (seite x1 y1) (seite x2 y2))
          ))))))


(defun b=punkt-auf-linie-p (punkt anfangspunkt endpunkt &key (delta 2) &allow-other-keys)
  "Autor: Gnter, 18.1.93"
  (let* ((deltapoint (make-point delta delta)))
    (b=linie-in-bereich-p anfangspunkt endpunkt
                          (subtract-points (the fixnum punkt) (the fixnum deltapoint))
                          (add-points (the fixnum punkt) (the fixnum deltapoint)))))


;;;;;;
;; bambi 16/4/94
;;;

(defun b=static-text (text textbreite-in-pixel x y &key (font b_normalschrift))
     (let* ((text-liste (b=string-umbrechen text textbreite-in-pixel font))
             (echte-breite (+ 5
                                      (b=min text-liste 
                                           :vergleichsfunktion '> 
                                           :TESTFUNKTION #'(LAMBDA(string)(STRING-WIDTH string font)))))
             (schrifthoehe (b=schrifthoehe font))
             (gesamt-hoehe (* schrifthoehe (length text-liste)))
             )
         (values
              (m->a=erzeuge-dialog-item
               '*b-static-text-dialog-item*
               :dialog-item-text text
               :view-position (make-point x y)
               :view-size (make-position echte-breite gesamt-hoehe)
               :view-font font
               )
              gesamt-hoehe
              )))


#|


(setq der (m->a=erzeuge-fenster
                    '*b-window*))

(setq eins
     (b=static-text "hallo , wer spricht den da und warum?"
     150 100 50)
     )

(add-widget eins der)


|#
